package com.sf.javase.day11.exception;

import org.junit.jupiter.api.Test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Calendar;

/**
 * ET  = ExceptionTest
 * 异常
 */
public class ET {
    public static void main(String[] args) {
//        String[] strs = {"qq","ww","ee"};
//        String ele = getEle(strs, 3);
//        System.out.println(ele);
//        Integer.MAX_VALUE

        int[][] arr = new int[3][1];
        System.out.println(arr[0].length);
    }

    //  数组下标越界异常
    public static String getEle(String[] strs , int index){
        String str = strs[index];
        return  str;
    }

    /**
     *处理异常：
     * try{
     *  //可能要发生的异常代码
     * }catch(  发生异常的类型1 e ){
     *  //  处理
     * }catch(  发生异常的类型2 e ){
     *     //  处理
     * }finally{
     *   关闭资源
     * }
     *
     *
     * 处理异常的方式：
     * 1、声明异常  在方法上   throws  异常类型 ...
     * 2、捕获异常   try {  可能要发生异常的代码}  cathch( 异常的数据类型  变量名  ){  处理方式} finally{  关闭资源（无论异常是否发生  都会执行）
     *
     * }
     * 3、抛出异常  throw   可以结合trycatch用
     *  throw  new 异常的数据类型(参数)
     *
     *  finally ：
     *      无论是否存在异常都需要执行    进行资源的关闭
     *     try    -  break(循环)   return       finally 会执行
     *     1、finally不执行：
     *      1、System.exit(0);
     *      2、宕机（意外情况）
     *
     *
     *
     * 总结：
     * throw  throws   try{}catch(){}finally{}
     * 1、什么异常   异常的体系
     * throwable     error   exception
     * 受检查异常    运行时异常
     * 编译时异常（处理）    运行    RuntimeException
     * io   file  url       arr         by    null     inputmis   inst
     *
     * 处理方式   throws    e1,e2
     * try        自定义异常  throw    runtimeException("....");
     *
     * 继承  重写方法     异常   <=  父类方法
     *
     */
    @Test
    public void t1() throws ClassNotFoundException {
        try {
            Class<?> aClass = Class.forName("java.lang.String");
            FileInputStream fis = new FileInputStream("Java秘籍.txt");
        } catch (ClassNotFoundException e) {
            throw new ClassNotFoundException("类找不到异常");
        } catch (FileNotFoundException e) {
            String message = e.getMessage();
            System.out.println(message);
        } finally {
            System.out.println("结束");
        }
    }

    @Test
    public void t3(){
        StringBuilder stringBuilder = new StringBuilder();
        String s = new String();
//        stringBuilder.append()
    }
}
