package com.sf.javase.day12.comparable;

import java.util.Arrays;

public class Student implements Comparable{

    private String name;
    private int score;

    public Student() {
    }

    public Student(String name, int score) {
        this.name = name;
        this.score = score;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getScore() {
        return score;
    }

    public void setScore(int score) {
        this.score = score;
    }

    @Override
    public String toString() {
        return "Student{" +
                "name='" + name + '\'' +
                ", score=" + score +
                '}';
    }

    @Override
    public int compareTo(Object o) {
        if(o instanceof Student){
            Student student = (Student) o;
            if(this.score != student.score){
                int compare = Double.compare(this.score, student.score);
                return compare;
            }else {
                return this.name.compareTo(student.name);
            }
        }
        return 0;
    }

    public static void main(String[] args) {
        Student[] students  = new Student[]{
          new Student("zs",100),
          new Student("zs",90),
          new Student("zs",80),
          new Student("ls",90),
        };
        System.out.println(Arrays.toString(students));
        Arrays.sort(students);
        System.out.println(Arrays.toString(students));
    }
}
