package com.sf;

import java.util.Arrays;

public class Main6 {

    // 快捷键 ctrl+alt+L  格式化
    public static void main(String[] args) {
        int[] arr = {1, 2, 3};
        // 1 2 3 0 0
        int[] newArr = Arrays.copyOf(arr, 5);
        // 1 2
        int[] newArr1 = Arrays.copyOf(arr, 2);
        System.out.println(Arrays.toString(newArr));
        System.out.println(Arrays.toString(newArr1));

        // 另一种数组拷贝的方法
        // 是 native 修饰的
        // 代表这个方法是由 jvm中的c++实现的 处理性能更高
        // 参数分别是 源对象 源的位置 目标对象 目标位置  拷贝的长度
        // public static native void arraycopy(Object src,  int  srcPos,
        //                                        Object dest, int destPos,
        //                                        int length);
        int[] copied = new int[10];
        // [1, 2, 3, 0, 0, 0, 0, 0, 0, 0]
        // [2, 3, 0, 0, 0, 0, 0, 0, 0, 0]
        System.arraycopy(arr, 1, copied, 0, 2);
        System.out.println(Arrays.toString(copied));
        // 本质上 Arrays.copyOf 就调用了  System.arraycopy
    }
}
